"use strict";

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es7.array.includes");

require("core-js/modules/es6.string.includes");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.object.set-prototype-of");

var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

exports.__esModule = true;

var React = require("react");

require("./index.css");

var avatarImg_1 = require("../../../../../../components/common/avatarImg"); // import GetSpotPos from './GetSpotPos';


var GetPosition_1 = require("./GetPosition");

var helper_1 = require("../../../../../../helper");

var jumpToPersonHome_1 = require("../../../../../../helper/jumpToPersonHome"); // import * as ReactDom from 'react-dom';


var UserItem =
/** @class */
function (_super) {
  __extends(UserItem, _super);

  function UserItem() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.getSize = function (index) {
      if (index == 0) {
        return 80;
      } else if (index < 5) {
        return 50;
      } else {
        return 30;
      }
    };

    _this.getAvatar = function (index) {
      var data = _this.props.data;
      if (!data.User) return React.createElement("div", null);
      return React.createElement("div", {
        className: "avatar-wrap",
        onClick: function onClick() {
          jumpToPersonHome_1.jumpPerson(data.User.UserId, 1);
        }
      }, React.createElement(avatarImg_1.default, {
        src: data.User.PersonalPictureUrl ? data.User.PersonalPictureUrl.l : '',
        color: data.User.AvatarColor || '',
        size: _this.getSize(index),
        name: data.User.Name
      }));
    };

    return _this;
  }

  UserItem.prototype.componentDidMount = function () {
    var _a = this.props,
        index = _a.index,
        data = _a.data,
        rewarded = _a.rewarded;
    var size = this.getSize(index); //调整位置
    // debugger

    if (rewarded) {
      if (this.bag) {
        var len = helper_1.getByteLen('红包元' + data.RewardAmount).len;
        var w = len * 6 + 18;
        this.bag.style.left = (size - w) / 2 + "px";
        this.bag.style.width = w + "px";
      }

      if (this.name) {
        var len = data.User.Name ? helper_1.getByteLen(data.User.Name).len : 0;
        var w = len * 6 + 18;
        this.name.style.marginLeft = (size - w) / 2 + "px";
        this.name.style.width = w + "px";
      }
    } else {
      if (this.bag) {
        var len = data.User.Name ? helper_1.getByteLen(data.User.Name).len : 0;
        var w = len * 6 + 18;
        this.bag.style.left = (size - w) / 2 + "px";
        this.bag.style.width = w + "px";
      }

      if (this.name) {
        var len = helper_1.getByteLen('打赏Ta').len;
        var w = len * 6 + 18;
        this.name.style.marginLeft = (size - w) / 2 + "px";
        this.name.style.width = w + "px";
      }
    }
  };

  UserItem.prototype.render = function () {
    var _this = this;

    var _a = this.props,
        index = _a.index,
        position = _a.position,
        data = _a.data,
        rewarded = _a.rewarded,
        handleGoReward = _a.handleGoReward,
        shoTip = _a.shoTip;
    if (!position) return null;
    var x = position.x,
        y = position.y;
    var TipShow = shoTip.includes(index);

    if (!rewarded) {
      return React.createElement("div", {
        className: "user-item-wrap",
        style: {
          left: x + 'px',
          top: y + 'px'
        }
      }, React.createElement("span", {
        className: "red-bag no-rewarded",
        style: {
          display: TipShow ? 'inline-block' : ''
        },
        ref: function ref(refs) {
          _this.bag = refs;
        }
      }, data.User.Name), this.getAvatar(index), React.createElement("span", {
        className: "name-wrap no-rewarded",
        ref: function ref(refs) {
          _this.name = refs;
        },
        onClick: function onClick() {
          handleGoReward(data.User);
        }
      }, "\u6253\u8D4FTa"));
    }

    return React.createElement("div", {
      className: "user-item-wrap",
      style: {
        left: x + 'px',
        top: y + 'px'
      }
    }, React.createElement("span", {
      className: "red-bag",
      style: {
        display: TipShow ? 'inline-block' : ''
      },
      ref: function ref(refs) {
        _this.bag = refs;
      }
    }, "\u7EA2\u5305", data.RewardAmount, "\u5143"), this.getAvatar(index), React.createElement("span", {
      className: "name-wrap",
      ref: function ref(refs) {
        _this.name = refs;
      },
      onClick: function onClick() {
        jumpToPersonHome_1.jumpPerson(data.User.UserId, 1);
      }
    }, data.User.Name));
  };

  return UserItem;
}(React.PureComponent);

var Radar =
/** @class */
function (_super) {
  __extends(Radar, _super);

  function Radar() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.subordinateUsersPos = [];
    _this.state = {
      size: 0,
      shoTip: []
    };
    _this.shoTip = [];
    _this.height = 0;
    _this.width = 0;

    _this.getConfig = function () {
      //元素大小信息
      var configuration = [40, 25, 25, 25, 25, 15, 15, 15, 15, 15];
      return configuration;
    };

    _this.getPosiotion = function () {
      _this.pos = undefined;
      _this.subordinateUsersPos = [];
      _this.pos = new GetPosition_1["default"](_this.getSpotPos, _this.getConfig(), _this.props.size / 2);
    };

    _this.getSpotPos = function (data) {
      var x = data.x,
          y = data.y;

      _this.subordinateUsersPos.push({
        x: x,
        y: y
      });

      if (_this.subordinateUsersPos.length == 10) {
        _this.forceUpdate();
      }
    };

    _this.getSize = function () {
      if (_this.radar && _this.radar.parentElement) {
        var h = _this.radar.parentElement.clientHeight;
        var w = _this.radar.parentElement.clientWidth;
        var min = Math.min(h, w);
        min != _this.state.size && _this.setState({
          size: min
        });
      }
    }; //不拖拽不重新计算位置刷新和toolTip不拖拽刷新冲突。


    _this.stopInterval = function () {
      clearInterval(_this.interval);
      var nodes = _this.radar.childNodes;

      for (var i = 0; i < nodes.length; i++) {
        nodes[i].getElementsByClassName('red-bag')[0].style.display = '';
      }

      _this.interval = undefined;
    }; // getArray=(num:number)=>{
    //     let tempArr:Array<number> = [];
    //     const {users} = this.props;
    //     let nodes = this.radar.childNodes;
    //     for(let i=0;i<nodes.length;i++){
    //         nodes[i].getElementsByClassName('red-bag')[0].style.display=''
    //     }
    //     for(let i = 0; i < num; i++){
    //         let j = Math.floor(Math.random()*users.length);
    //         tempArr.push(j);
    //         if(this.userItems && this.userItems.length && this.userItems[j]){
    //             let dom:any = ReactDom.findDOMNode(this.userItems[j]);
    //             if(dom){
    //                 dom.getElementsByClassName('red-bag')[0].style.display = 'inline-block';
    //             }
    //         }
    //     }
    //     return tempArr;
    // }


    _this.getArray = function (num) {
      var temArr = [];
      var users = _this.props.users;

      for (var i = 0; i < num; i++) {
        var j = Math.floor(Math.random() * users.length);
        temArr.push(j);
      }

      _this.setState({
        shoTip: temArr
      });
    };

    _this.resetTag = function () {
      //计算出 0-3 个随机数，随机数范围（0-9）；
      var num = Math.floor(Math.random() * 10 % 4); // 0-3个
      // let arr = this.getArray(num)//生成num个（0-9）的随机数。
      // this.shoTip = arr;

      _this.getArray(num); //生成num个（0-9）的随机数。
      // this.setState({shoTip:arr});

    };

    _this.reStartInterval = function () {
      var ipad = navigator.userAgent.toLowerCase().match(/ipad/i);

      if (ipad) {
        return;
      }

      clearInterval(_this.interval);
      _this.interval = undefined;
      _this.interval = setInterval(_this.resetTag, 3000);
    };

    return _this;
  }

  Radar.prototype.componentDidMount = function () {
    this.getSize();
    this.getPosiotion();
    this.reStartInterval();
  };

  Radar.prototype.shouldComponentUpdate = function () {
    var _a = this.props,
        pHeight = _a.pHeight,
        pWidth = _a.pWidth;

    if (pHeight == this.height && pWidth == this.width) {
      return false;
    } else {
      return true;
    }
  };

  Radar.prototype.componentWillUnmount = function () {
    clearInterval(this.interval);
  };

  Radar.prototype.componentDidUpdate = function () {
    var backDom = document.getElementsByClassName('react-grid-placeholder')[0];

    if (backDom) {
      this.listenStart = true;
    }

    if (!backDom && this.listenStart) {
      this.listenStart = false;
      var _a = this.props,
          pHeight = _a.pHeight,
          pWidth = _a.pWidth;
      this.height = pHeight;
      this.width = pWidth;
      this.getPosiotion();
    }

    this.getSize();
  };

  Radar.prototype.render = function () {
    var _this = this;

    var _a = this.props,
        users = _a.users,
        rewarded = _a.rewarded,
        handleGoReward = _a.handleGoReward;
    var _b = this.state,
        size = _b.size,
        shoTip = _b.shoTip;
    if (!this.subordinateUsersPos.length) return null;
    this.userItems = new Array(users.length);
    return React.createElement("div", {
      className: "radar-wrap",
      style: {
        width: size + 'px',
        height: size + 'px'
      },
      onMouseEnter: this.stopInterval,
      onMouseLeave: this.reStartInterval,
      ref: function ref(refs) {
        _this.radar = refs;
      }
    }, !!users.length && users.map(function (user, k) {
      return React.createElement(UserItem, {
        key: "user-item" + k,
        shoTip: shoTip,
        ref: function ref(refs) {
          if (refs) {
            _this.userItems[k] = refs;
          }
        },
        handleGoReward: handleGoReward,
        rewarded: rewarded,
        position: _this.subordinateUsersPos[k],
        index: k,
        data: user
      });
    }));
  };

  return Radar;
}(React.Component);

exports["default"] = Radar;