"use strict";

require("core-js/modules/es6.object.set-prototype-of");

var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

exports.__esModule = true;

var React = require("react");

require("./rewarded.css");

var defaultData_1 = require("../defaultData");

var componentTagFilter_1 = require("../../../../../components/common/componentTagFilter");

var RewardedList_1 = require("./RewardedList");

var helper_1 = require("../../../../../helper");

var noDataView_1 = require("../../../../../components/common/noDataView");

function GoReward(_a) {
  var handleGoReward = _a.handleGoReward;
  var dataUdc = encodeURIComponent(JSON.stringify({
    ext: {
      type: 'reward',
      data: 'rewardwrap'
    }
  }));
  return React.createElement("span", {
    className: "go-reward",
    "data-udc": dataUdc,
    onClick: function onClick() {
      handleGoReward();
    }
  }, "\u5C1D\u8BD5\u6253\u8D4F");
}

var RewardWrap =
/** @class */
function (_super) {
  __extends(RewardWrap, _super);

  function RewardWrap() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.state = {
      selectedFilter: 0
    };

    _this.getData = function (k) {
      var url = helper_1.getApiUrl("proxy/GetUPaaSCoreGateway/Reward/GetLatestReward?scope=" + k);
      helper_1.taker(url).then(function (res) {
        if (res.OperationResult) {
          _this.setState({
            rewardedDatas: res.OperationObject
          });
        }
      });
    };

    _this.handleFilter = function (k) {
      _this.getData(k);

      _this.setState({
        selectedFilter: k
      });
    };

    return _this;
  }

  RewardWrap.prototype.componentDidMount = function () {
    this.getData(0);
  };

  RewardWrap.prototype.render = function () {
    var _a = this.state,
        selectedFilter = _a.selectedFilter,
        rewardedDatas = _a.rewardedDatas;
    var goReward = this.props.goReward;
    if (selectedFilter == 0 && (!rewardedDatas || !rewardedDatas.length)) return React.createElement("div", {
      className: "rewarded"
    }, React.createElement(noDataView_1.default, {
      icon: 1,
      text: "\u6682\u65E0\u5458\u5DE5\u83B7\u5F97\u6253\u8D4F"
    }), React.createElement(GoReward, {
      handleGoReward: goReward
    }));
    return React.createElement("div", {
      className: "rewarded"
    }, React.createElement(componentTagFilter_1.default, {
      tagData: defaultData_1.rewardedFilter,
      handleClick: this.handleFilter,
      selectexIndex: selectedFilter
    }), rewardedDatas && rewardedDatas.length ? React.createElement(RewardedList_1.default, {
      rewardedData: rewardedDatas,
      goReward: goReward
    }) : React.createElement("div", {
      className: "rewarded"
    }, React.createElement(noDataView_1.default, {
      icon: 1,
      text: "\u6682\u65E0\u5458\u5DE5\u83B7\u5F97\u6253\u8D4F"
    }), React.createElement(GoReward, {
      handleGoReward: goReward
    })));
  };

  return RewardWrap;
}(React.Component);

exports["default"] = RewardWrap;