"use strict";

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.set-prototype-of");

var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

exports.__esModule = true;

var React = require("react");

require("./index.css");

var avatarImg_1 = require("../../../../../components/common/avatarImg");

var jumpToPersonHome_1 = require("../../../../../helper/jumpToPersonHome");

var scrollWrap_1 = require("../../../../../components/common/scrollWrap");

var helper_1 = require("../../../../../helper");

var tool_tip_1 = require("@beisen/tool-tip");

var SelfOrder =
/** @class */
function (_super) {
  __extends(SelfOrder, _super);

  function SelfOrder() {
    return _super !== null && _super.apply(this, arguments) || this;
  }

  SelfOrder.prototype.render = function () {
    var data = this.props.data;
    return React.createElement("div", {
      className: "bound-self-order"
    }, React.createElement("span", {
      className: "self-head",
      onClick: function onClick() {
        jumpToPersonHome_1.jumpPerson(data.User.UserId, 1);
      }
    }, React.createElement(avatarImg_1.default, {
      size: 20,
      color: data.User.Avatar.Color,
      src: data.User.Avatar.Small,
      name: data.User.Name
    })), React.createElement("span", {
      className: "bound-self-order-describe"
    }, React.createElement("span", null, "\u6211\u7B2C"), React.createElement("span", {
      className: "postion-num"
    }, data.Position), React.createElement("span", null, "\u540D")), React.createElement("span", {
      className: "agree-time"
    }, React.createElement("span", null, "\u83B7\u8D4F"), React.createElement("span", {
      className: "reward-count"
    }, data.RankBasis), React.createElement("span", null, "\u6B21")));
  };

  return SelfOrder;
}(React.Component);

var HaveDataView =
/** @class */
function (_super) {
  __extends(HaveDataView, _super);

  function HaveDataView(p) {
    var _this = _super.call(this, p) || this;

    _this.agree = function (e, uid, key) {
      e.stopPropagation();
      if (_this.isfetching) return;
      _this.isfetching = true;
      var _a = _this.props,
          datas = _a.datas,
          fanwei = _a.fanwei; // const { agree0, agree1, agree2 } = this.state;

      var thumbUped = _this.state["agree" + key];
      var data = datas[key]; //uid 点赞取消赞接口－－加限制

      var urlStr = '';

      if (thumbUped) {
        //取消赞
        urlStr = 'proxy/PostUPaaSCoreGateway/Like/CancelLike';
      } else {
        //点赞
        urlStr = 'proxy/PostUPaaSCoreGateway/Like/Like';
      }

      var url = helper_1.getApiUrl(urlStr);
      var mapDianZan = [0, 1, 1, 2, 3, 4];

      if (data) {
        helper_1.taker(url, 'POST', {
          "appObj": {
            "AppObjId": data.User.UserId,
            "AppObjType": 9501005,
            "PeriodType": mapDianZan[fanwei],
            "ReceiverId": data.User.UserId
          }
        }).then(function (res) {
          _this.timeOut && clearTimeout(_this.timeOut);
          _this.timeOut = setTimeout(function () {
            _this.isfetching = false;
          }, 300);

          if (res.Code == 200) {
            //点赞｜取消赞结束，改状态。
            _this.state["agree" + key] = !thumbUped;

            _this.forceUpdate();
          }
        });
      }
    };

    _this.getWidth = function (pos) {
      var tempLen = pos.toString().length;
      return 38 + tempLen * 7 + 'px';
    };

    _this.fillData = function (datas, len) {
      var tempArr = datas.slice();

      for (var index = 0; index < len; index++) {
        tempArr.push(undefined);
      }

      return tempArr;
    };

    var datas = p.datas;
    _this.state = {
      agree0: datas[0] ? !datas[0].CanThumbUp : false,
      agree1: datas[1] ? !datas[1].CanThumbUp : false,
      agree2: datas[2] ? !datas[2].CanThumbUp : false
    };
    return _this;
  }

  HaveDataView.prototype.componentWillReceiveProps = function (np) {
    var datas = np.datas;
    var state = {
      agree0: datas[0] ? !datas[0].CanThumbUp : false,
      agree1: datas[1] ? !datas[1].CanThumbUp : false,
      agree2: datas[2] ? !datas[2].CanThumbUp : false
    };
    this.setState(state);
  };

  HaveDataView.prototype.render = function () {
    var _this = this;

    var datas = this.props.datas;
    var positionClass = ['middle', 'left', 'right'];
    var aimLen = 3 - datas.length;
    var tempDatas = aimLen <= 0 ? datas.slice(0, 3) : this.fillData(datas, aimLen);
    return React.createElement("div", {
      className: "have-data-view"
    }, tempDatas.map(function (data, k) {
      var isSelf = false;

      if (data) {
        var userInfo = helper_1.getUserInfo();
        isSelf = data.User.UserId == userInfo.Id;
      }

      return data ? React.createElement("span", {
        className: positionClass[k],
        key: "item-data" + k,
        onClick: function onClick() {
          jumpToPersonHome_1.jumpPerson(data.User.UserId, 1);
        }
      }, React.createElement("div", {
        className: "hover-show-agree"
      }, React.createElement(avatarImg_1.default, {
        name: data.User.Name,
        src: data.User.Avatar.Medium,
        size: k == 0 ? 50 : 40,
        color: data.User.Avatar.Color
      }), React.createElement(tool_tip_1.default, {
        slide: false,
        title: data.User.Name
      }, React.createElement("span", {
        className: "name " + (k == 0 ? 'is-self' : '')
      }, data.User.Name)), React.createElement("div", {
        style: {
          display: isSelf ? 'none' : ''
        },
        className: _this.state["agree" + k] ? 'agree-icon font-agree' : 'agree-icon font-agree-border',
        onClick: function onClick(e) {
          _this.agree(e, data.User.UserId, k);
        }
      })), React.createElement("div", {
        className: "describe",
        style: {
          width: '58px',
          left: '-7px',
          textAlign: 'center',
          whiteSpace: 'nowrap'
        }
      }, data.RankBasis)) : React.createElement("span", {
        key: "item-data" + k,
        className: "no-data " + positionClass[k]
      }, " ");
    }));
  };

  return HaveDataView;
}(React.Component);

var NoDataView =
/** @class */
function (_super) {
  __extends(NoDataView, _super);

  function NoDataView() {
    return _super !== null && _super.apply(this, arguments) || this;
  }

  NoDataView.prototype.render = function () {
    return React.createElement("div", {
      className: "no-data-view-order"
    }, React.createElement("span", {
      className: "left"
    }, " "), React.createElement("span", {
      className: "middle"
    }, " "), React.createElement("span", {
      className: "right"
    }, " "));
  };

  return NoDataView;
}(React.Component);

var OrderBody =
/** @class */
function (_super) {
  __extends(OrderBody, _super);

  function OrderBody(p) {
    var _this = _super.call(this, p) || this;

    _this.genfriendlyTips = function () {
      return React.createElement("div", {
        className: "encourage-language"
      }, "\u4F60\u8FD8\u6CA1\u6709\u4E0A\u699C\u54E6\uFF0C\u8981\u7EE7\u7EED\u52A0\u6CB9\uFF01");
    };

    _this.udc = encodeURIComponent(JSON.stringify({
      ext: {
        type: "reward",
        desc: "entry",
        from: "c-reward-news"
      }
    }));
    return _this;
  }

  OrderBody.prototype.componentDidMount = function () {// loadRewardPop()
  };

  OrderBody.prototype.render = function () {
    var _a = this.props,
        data = _a.data,
        datas = _a.datas,
        fanwei = _a.fanwei,
        isSelf = _a.isSelf;
    var userInfo = helper_1.getUserInfo();
    return React.createElement(scrollWrap_1.default, {
      height: "100%"
    }, React.createElement("div", {
      className: "bound-order-body-wraps"
    }, React.createElement("div", {
      className: "order-three-contain"
    }, datas && datas.length ? React.createElement(HaveDataView, {
      datas: datas,
      fanwei: fanwei,
      selfId: data ? data.User.UserId : userInfo.Id
    }) : React.createElement("div", {
      className: "no-data-wrap"
    }, React.createElement("div", {
      className: "cover"
    }), React.createElement(NoDataView, null))), datas.length > 0 && data ? data && data.RankBasis < 0 ? isSelf && this.genfriendlyTips() : isSelf && React.createElement(SelfOrder, {
      data: data
    }) : isSelf && React.createElement("div", {
      className: "go-reward-in-reward-order"
    }, React.createElement("div", {
      className: "go-reward-in-reward-order-language"
    }, "\u6392\u884C\u699C\u865A\u4F4D\u4EE5\u5F85\uFF0C\u8C01\u662F\u4F60\u5FC3\u4E2D\u6700\u68D2\u7684ta ?"), React.createElement("div", {
      className: "go-reward-in-reward-order-a",
      onClick: helper_1.goReward,
      "data-udc": this.udc
    }, "\u53BB\u6253\u8D4F"))));
  };

  return OrderBody;
}(React.PureComponent);

exports["default"] = OrderBody;