"use strict";

exports.__esModule = true;

var React = require("react");

var scrollWrap_1 = require("../../../../../components/common/scrollWrap");

var avatarImg_1 = require("../../../../../components/common/avatarImg");

var jumpToPersonHome_1 = require("../../../../../helper/jumpToPersonHome");

function RewardItem(_a) {
  var data = _a.data;
  if (!data.User) return React.createElement("div", null);
  return React.createElement("div", {
    className: "reward-item"
  }, React.createElement("span", {
    className: "head-image",
    onClick: function onClick() {
      jumpToPersonHome_1.jumpPerson(data.User.UserId, 1);
    }
  }, React.createElement(avatarImg_1.default, {
    size: 30,
    name: data.User.Name,
    color: data.User.AvatarColor || '',
    src: data.User.PersonalPictureUrl ? data.User.PersonalPictureUrl.s : ''
  })), React.createElement("span", {
    className: "item-containner"
  }, React.createElement("div", {
    className: "top-wrap"
  }, React.createElement("span", {
    className: "describe",
    style: {
      maxWidth: "calc(100% - 70px)"
    }
  }, React.createElement("span", {
    className: "rewarded-name",
    onClick: function onClick() {
      jumpToPersonHome_1.jumpPerson(data.User.UserId, 1);
    }
  }, data.User.Name), React.createElement("span", {
    className: "after"
  }, "\u83B7\u8D4F")), React.createElement("span", {
    className: "reward-time"
  }, data.RewardTime)), React.createElement("div", {
    className: "bottom-wrap"
  }, data.Tags && data.Tags.map(function (tag, k) {
    return React.createElement("span", {
      className: "item-tag",
      key: "item-tag" + k
    }, tag);
  }))));
}

function RewardedList(_a) {
  var rewardedData = _a.rewardedData,
      goReward = _a.goReward;
  return React.createElement("div", {
    className: "rewarded-list"
  }, React.createElement(scrollWrap_1.default, {
    height: "calc(100% - 5px)"
  }, rewardedData.map(function (data, k) {
    return React.createElement(RewardItem, {
      data: data,
      key: "reward-item" + k
    });
  })));
}

exports["default"] = RewardedList;